#ifndef MessageFacility_MessageService_ThreadQueue_h
#define MessageFacility_MessageService_ThreadQueue_h
// -*- C++ -*-
//
// Package:     MessageService
// Class  :     ThreadQueue
//
/**\class ThreadQueue ThreadQueue.h FWCore/MessageService/interface/ThreadQueue.h

 Description: <one line class summary>

 Usage:
    <usage>

*/
//
// Original Author:  mf and cdj
//         Created:  Fri Aug  7 10:19:58 CDT 2009
// $Id: ThreadQueue.h,v 1.1 2009/08/12 22:22:01 fischler Exp $
//

#include "messagefacility/MessageLogger/MessageLoggerQ.h"
#include "messagefacility/Utilities/SingleConsumerQ.h"




namespace mf {
namespace service {

class ThreadQueue
{

   public:
      ThreadQueue();
      virtual ~ThreadQueue();

      // ---------- const member functions ---------------------

      // ---------- static member functions --------------------

      // ---------- member functions ---------------------------

  // ---  obtain a message from the queue:
  void  consume( MessageLoggerQ::OpCode & opcode, void * & operand );

  // ---  place a message onto the queue:
  void  produce( MessageLoggerQ::OpCode opcode, void *   operand );


   private:
      ThreadQueue(const ThreadQueue&); // stop default

      const ThreadQueue& operator=(const ThreadQueue&); // stop default

      // ---------- member data --------------------------------

  // --- buffer parameters:  (were private but needed by MainTrhreadMLscribe
  static  const int  buf_depth = 500;
  static  const int  buf_size  = sizeof(MessageLoggerQ::OpCode)
                               + sizeof(void *);
  SingleConsumerQ  m_buf;

};

} // end namespace service
} // end namespace mf

#endif
